//**************************************************************//
//  Effect File exported by RenderMonkey 1.6
//
//  - Although many improvements were made to RenderMonkey FX  
//    file export, there are still situations that may cause   
//    compilation problems once the file is exported, such as  
//    occasional naming conflicts for methods, since FX format 
//    does not support any notions of name spaces. You need to 
//    try to create workspaces in such a way as to minimize    
//    potential naming conflicts on export.                    
//    
//  - Note that to minimize resulting name collisions in the FX 
//    file, RenderMonkey will mangle names for passes, shaders  
//    and function names as necessary to reduce name conflicts. 
//**************************************************************//

//--------------------------------------------------------------//
// Full Car Paint Effect
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// Pass 0
//--------------------------------------------------------------//
float4x4 view_proj_matrix : WorldViewProjectionTranspose;
float4x4 inv_world_matrix : WorldInverseTranspose;
float4x4 inv_view_matrix : ViewInverseTranspose;

//----------------------------------------------------------------------------------//
// Phenomenological car paint visual effect: Simulates build up of paint coats     
// on the metallic surface of a car or any other object. This visual effect        
// emulates the suspended layers of microflakes in the paint coat as well as        
// blends between several colors of paint based on the viewing angle.          
//                                        
// Author: Natalya Tatarchuk                
//      (based on the original assembly shader written by John Isidoro)       
//                                        
// Used in ATI's Car demo for Radeon 9700 launch, found here:             
//       http://www.ati.com/developer/demos/r9700.html                
//                                        
// (C) ATI Research, 2003                   
//----------------------------------------------------------------------------------//

float4x4 tTex: TEXTUREMATRIX <string uiname="Texture Transform";>;
float4x4 ViewRotate;
struct VS_OUTPUT
{
   float4 Pos        : POSITION;
   float2 Tex        : TEXCOORD0;
   float3 Tangent    : TEXCOORD1;
   float3 Binormal   : TEXCOORD2;
   float3 Normal     : TEXCOORD3;
   float3 View       : TEXCOORD4;
   float3 SparkleTex : TEXCOORD5;
};

VS_OUTPUT Car_Paint_Effect_Group_DX9_Full_Car_Paint_Effect_Pass_0_Vertex_Shader_HLSL_main(    float4 Pos      : POSITION, 
         float3 Normal  : NORMAL,
         float2 Tex     : TEXCOORD0,
         float3 Tangent : TANGENT,
         float3 Binormal: BINORMAL )
{
   VS_OUTPUT Out = (VS_OUTPUT) 0; 

   // Propagate transformed position out:
   Out.Pos = mul( view_proj_matrix, Pos);

   // Compute view vector: 
   Out.View = normalize(mul(mul(inv_view_matrix, ViewRotate), float4( 0, 0, 0, 1)) - Pos );

   // Propagate texture coordinates:
   Out.Tex = mul(float4(Tex, 0, 1), tTex);

   // Propagate tangent, binormal, and normal vectors to pixel shader:
   Out.Normal   = Normal;
   Out.Tangent  = Tangent;
   Out.Binormal = -Binormal;
  
   // Compute microflake tiling factor:
   Out.SparkleTex = float4( Tex * 25.0, 0, 1 );
   
   return Out;
}






float microflakePerturbation
<
   string UIName = "microflakePerturbation";
   string UIWidget = "Numeric";
   bool UIVisible =  false;
> = float( 1.00 );
float brightnessFactor
<
   string UIName = "brightnessFactor";
   string UIWidget = "Numeric";
   bool UIVisible =  false;
> = float( 8.00 );
float glossLevel
<
   string UIName = "glossLevel";
   string UIWidget = "Numeric";
   bool UIVisible =  false;
> = float( 0.00 );
float4 paintColorMid : Color
<
   string UIName = "paintColorMid";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.60, 0.00, 0.00, 0.00 );

float4 paintColor2 : Color
<
   string UIName = "paintColor2";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.00, 0.35, -0.35, 0.00 );

float4 flakeLayerColor : Color
<
   string UIName = "flakeLayerColor";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.50, 0.50, 0.00, 0.00 );

float normalPerturbation
<
   string UIName = "normalPerturbation";
   string UIWidget = "Numeric";
   bool UIVisible =  false;
   float UIMin = -1.00;
   float UIMax = 1.00;
> = float( 1.00 );

float microflakePerturbationA
<
   string UIName = "microflakePerturbationA";
   string UIWidget = "Numeric";
   bool UIVisible =  false;
> = float( 0.10 );

float4 paintColor0 : Color
<
   string UIName = "paintColor0";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.40, 0.00, 0.35, 0.00 );

texture microflakeNMap_Tex;
sampler microflakeNMap = sampler_state
{
   Texture = (microflakeNMap_Tex);
   MAGFILTER = Point;
   MINFILTER = Point;
   MIPFILTER = Point;
   MIPMAPLODBIAS = 0.000000;
   AddressU = wrap;
   AddressV = wrap;
};
texture normalMap_Tex;
sampler normalMap = sampler_state
{
   Texture = (normalMap_Tex);
   MAGFILTER = LINEAR;
   MINFILTER = LINEAR;
   MIPFILTER = LINEAR;
   MIPMAPLODBIAS = 0.000000;
};
texture showroomMap_Tex;
sampler showroomMap = sampler_state
{
   Texture = (showroomMap_Tex);
   MAGFILTER = LINEAR;
   MINFILTER = LINEAR;
   MIPFILTER = LINEAR;
   MIPMAPLODBIAS = 0.000000;
};
//----------------------------------------------------------------------------------//
// Phenomenological car paint visual effect: Simulates build up of paint coats	    //
// on the metallic surface of a car or any other object. This visual effect 	    //
// emulates the suspended layers of microflakes in the paint coat as well as 	    //
// blends between several colors of paint based on the viewing angle.		    //
//												    //
// Author: Natalya Tatarchuk 							 	    //
//		(based on the original assembly shader written by John Isidoro)	    //
//												    //
// Used in ATI's Car demo for Radeon 9700 launch, found here:			    //
// 		http://www.ati.com/developer/demos/r9700.html				    //
//												    //
// (C) ATI Research, 2003									    //
//----------------------------------------------------------------------------------//

float4 Car_Paint_Effect_Group_DX9_Full_Car_Paint_Effect_Pass_0_Pixel_Shader_HLSL_main( float4 Diff	 : COLOR0,
	    	 float2 Tex        : TEXCOORD0,
	    	 float3 Tangent    : TEXCOORD1,
	    	 float3 Binormal   : TEXCOORD2,
	    	 float3 Normal     : TEXCOORD3,
	    	 float3 View       : TEXCOORD4,
	    	 float3 SparkleTex : TEXCOORD5 ) : COLOR
{ 
	// fetch from the incoming normal map:
	float3 vNormal = tex2D( normalMap, Tex );

	// Scale and bias fetched normal to move into [-1.0, 1.0] range:
	vNormal = 2 * vNormal - 1.0;

	// Microflakes normal map is a high frequency normalized
      // vector noise map which is repeated across all surface. 
	// Fetching the value from it for each pixel allows us to 
	// compute perturbed normal for the surface to simulate
	// appearance of microflakes suspected in the coat of paint:
	float3 vFlakesNormal = tex2D( microflakeNMap, SparkleTex );
	
	// Don't forget to bias and scale to shift color into [-1.0, 1.0] range:
	vFlakesNormal = 2 * vFlakesNormal - 1.0;

	// This shader simulates two layers of microflakes suspended in 
	// the coat of paint. To compute the surface normal for the first layer,
	// the following formula is used: 
	//	Np1 = ( a * Np + b * N ) /  || a * Np + b * N || where a << b
	//
	float3 vNp1 = microflakePerturbationA * vFlakesNormal + normalPerturbation * vNormal ; 

	// To compute the surface normal for the second layer of microflakes, which
	// is shifted with respect to the first layer of microflakes, we use this formula:
	// 	Np2 = ( c * Np + d * N ) / || c * Np + d * N || where c == d
	// 
	float3 vNp2 = microflakePerturbation * ( vFlakesNormal + vNormal ) ;

	// The view vector (which is currently in world space) needs to be normalized.
	// This vector is normalized in the pixel shader to ensure higher precision of
	// the resultinv view vector. For this highly detailed visual effect normalizing
	// the view vector in the vertex shader and simply interpolating it is insufficient
	// and produces artifacts.
	float3 vView =  normalize( View );

	// Transform the surface normal into world space (in order to compute reflection
	// vector to perform environment map look-up):
	float3x3 mTangentToWorld =  transpose(float3x3( Tangent, Binormal, Normal ));
	float3   vNormalWorld    = normalize( mul( mTangentToWorld, vNormal ));

	// Compute reflection vector resulted from the clear coat of paint on the metallic
	// surface:
	float  fNdotV 	 = saturate(dot( vNormalWorld, vView));
	float3 vReflection = 2 * vNormalWorld * fNdotV - vView;

	// Here we just use a constant gloss value to bias reading from the environment
	// map, however, in the real demo we use a gloss map which specifies which 
	// regions will have reflection slightly blurred.
	float fEnvBias = glossLevel;

	// Sample environment map using this reflection vector:
	float4 envMap = texCUBEbias( showroomMap, float4( vReflection.zxy, fEnvBias ) );

	// Premultiply by alpha:
        envMap.rgb = envMap.rgb * envMap.a;

	// Brighten the environment map sampling result:
	envMap.rgb *= brightnessFactor;

	// Compute modified Fresnel term for reflections from the first layer of
	// microflakes. First transform perturbed surface normal for that layer into 
	// world space and then compute dot product of that normal with the view vector:
	float3 vNp1World = normalize( mul( mTangentToWorld, vNp1 ) );
	float  fFresnel1 = saturate( dot( vNp1World, vView )) ;

	// Compute modified Fresnel term for reflections from the second layer of 
	// microflakes. Again, transform perturbed surface normal for that layer into 
	// world space and then compute dot product of that normal with the view vector:
	float3 vNp2World = normalize( mul( mTangentToWorld, vNp2 ));
	float  fFresnel2 = saturate( dot( vNp2World, vView )) ;

	//
	// Compute final paint color: combines all layers of paint as well as two layers
	// of microflakes
	//
	float  fFresnel1Sq = fFresnel1 * fFresnel1;

	float4 paintColor = fFresnel1   * paintColor0 + 
				  fFresnel1Sq * paintColorMid +
				  fFresnel1Sq * fFresnel1Sq * paintColor2 +
				  pow( fFresnel2, 32 ) * flakeLayerColor;

	// Combine result of environment map reflection with the paint color:
	float  fEnvContribution = (1.0 - 0.5 * fNdotV) * sqrt( dot(paintColor, float3(0.222, 0.707, 0.071)) );

	float4 finalColor;
	finalColor.a = 1.0;
	finalColor.rgb = envMap * fEnvContribution + paintColor;
				  
	return finalColor;

}


//--------------------------------------------------------------//
// Technique Section for MultiTone Car Paint Effect.Car Paint Effect Group_DX9.Full Car Paint Effect
//--------------------------------------------------------------//
technique Full_Car_Paint_Effect
{
   pass Pass_0
   {
      VertexShader = compile vs_1_1 Car_Paint_Effect_Group_DX9_Full_Car_Paint_Effect_Pass_0_Vertex_Shader_HLSL_main();
      PixelShader = compile ps_2_0 Car_Paint_Effect_Group_DX9_Full_Car_Paint_Effect_Pass_0_Pixel_Shader_HLSL_main();
   }

}
